function [MI_est]= MI_measure(X)
% MI_MEASURE Cumulant based approximation of mutual information

% Ivica Kopriva May 22 2006

[N T] = size(X);
MI_est = 0;
n = 1;

while n < N
  for m = n+1:N  
        c11 = crosscorr(X(n,:),X(m,:));
        [c13, c31, c22, c12, c21] = crosscumulants(X(n,:),X(m,:));
        MI_est = MI_est + (1/4)*c11*c11 + (1/12)*(c12*c12 + c21*c21) + (1/48)*(c13*c13 + c31*c31 + c22*c22);
  end
  n = n + 1;
end

end

function c11 = crosscorr(x1, x2)
  T = length(x1);
  x1 = x1 - mean(x1);
  x2 = x2 - mean(x2);

  m11 = sum(x1 .* x2) / T;
  m21 = sum(x1 .* x1) / T;
  m22 = sum(x2 .* x2) / T;
  c11 = m11 / sqrt(m21) / sqrt (m22);
end

function [c13, c31, c22, c12, c21] = crosscumulants(x1,x2);
  T = length(x1);
  x1 = x1 - mean(x1);
  x2 = x2 - mean(x2);
  
  c13 = sum(x1.*x2.*x2.*x2)/T - 3*sum(x1.*x2)/T * sum(x2.*x2)/T;
  c31 = sum(x1.*x1.*x1.*x2)/T - 3*sum(x1.*x2)/T * sum(x1.*x1)/T;
  c22 = sum(x1.*x1.*x2.*x2)/T -   sum(x1.*x1)/T * sum(x2.*x2)/T - 2*(sum(x1.*x2)/T)^2;
  
  c12 = sum(x1.*x2.*x2)/T;
  c21 = sum(x1.*x1.*x2)/T;
end
