function error = amari_error(Q)
% AMARI_ERROR comuputes Amari's error
%    Amari's error is a measure of deviation from the generalized permutation matrix

[N,N]=size(Q);
error = 0;

for i=1:N
    qm1=max(abs(Q(i,:)));
    qm2=max(abs(Q(:,i)));
    err1=0;
    err2=0;
    for k=1:N
        err1=err1 + abs(Q(i,k))/qm1;
        err2=err2 + abs(Q(k,i))/qm2;
    end
   error = error + err1 - 1 + err2 - 1;
end
error = error/N/(N-1);