function res = showMI2(MI)
% SHOWMI2 shows the MI assoiciated to 2D WP nodes
    [r,c] = size(MI);

    n = floor(log2(r)/2); % number of decomposition levels
    l = 4.^[0:n]; % number of planes at each decomposition level
    lsum = cumsum(l);
    ll = n+1;

    res = zeros(l(end), ll);

    step = 1;
    while ll > 1,
        res(step*[1:l(ll)],ll) = MI(lsum(ll-1)+1:lsum(ll));
        step = 4*step;
        ll = ll-1;
    end
    res(step*[1:l(ll)],ll) = MI(1:lsum(ll));
    